var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { useFieldApi, useFormApi } from '@data-driven-forms/react-form-renderer';
import { Button, FormField, Pane } from 'evergreen-ui';
import FieldArrayProvider from '@data-driven-forms/react-form-renderer/field-array';
;
var FieldArrayItem = function (_a) {
    var name = _a.name, fields = _a.fields, length = _a.length, minItems = _a.minItems, remove = _a.remove;
    var renderForm = useFormApi().renderForm;
    var editedFields = fields.map(function (field, index) {
        var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
        return __assign(__assign({}, field), { name: computedName, key: "".concat(name, "-").concat(index) });
    });
    var isRemoveDisabled = length <= minItems;
    return React.createElement(Pane, { display: "flex", flexDirection: "column", border: true, marginBottom: 4, padding: 4 },
        editedFields.map(function (field) { return renderForm([field]); }),
        React.createElement(Button, { size: "small", disabled: isRemoveDisabled, onClick: remove, marginTop: 4, alignSelf: "flex-end" }, "Remove"));
};
var FieldArray = function (props) {
    var _a = useFieldApi(props), input = _a.input, meta = _a.meta, arrayValidator = _a.arrayValidator, fields = _a.fields, defaultItem = _a.defaultItem, maxItems = _a.maxItems, minItems = _a.minItems, rest = __rest(_a, ["input", "meta", "arrayValidator", "fields", "defaultItem", "maxItems", "minItems"]);
    return React.createElement("div", null,
        React.createElement(FieldArrayProvider, { key: input.name, input: input, meta: meta, name: input.name, validate: arrayValidator }, function (_a) {
            var _b = _a.fields, map = _b.map, _c = _b.value, value = _c === void 0 ? [] : _c, push = _b.push, remove = _b.remove;
            return (React.createElement(Pane, { display: "flex", flexDirection: "column" },
                React.createElement(Pane, { display: "flex" },
                    React.createElement(FormField, __assign({ flex: "1" }, rest)),
                    React.createElement(Button, __assign({ size: "small", disabled: value.length >= maxItems }, (!(value.length >= maxItems) && { onClick: function () { return push(typeof defaultItem === 'function' ? defaultItem(value) : defaultItem); } })), "Add")),
                value.length === 0 && React.createElement(Pane, { textAlign: "center" }, "---"),
                map(function (name, index) { return React.createElement(FieldArrayItem, { name: name, remove: function () { return remove(index); }, fields: fields, length: value.length, minItems: minItems }); })));
        }));
};
export default FieldArray;
//# sourceMappingURL=field-array.js.map